;
; CvOppb`
;

	relaxed on


; 0x0000`0x0007
; RST00
; LDH ($FFxx),A
;
	org	$0000
	jp	LDH_TOMEM

; 0x0008`0x000f
; RST08
; LDH A,($FFxx)
;
	org	$0008
	jp	LDH_FRMEM

; 0x0010`0x0017
; RST10
; LD (HL),A
; ^C}bv#0/1ɏ
;
	org	$0010
	push	af
	call	WR_TILEMAP
	pop	af
	ret

; 0x0018`0x001f
; RST18
; LD (DE),A
; ^C}bv#0/1ɏ
;
	org	$0018
	ex	de,hl
	push	af
	call	WR_TILEMAP
	pop	af
	ex	de,hl
	ret

; 0x0020`0x0027
; RST20
; LD A,(HL+)
;
	org	$0020
	ld	a,(hl)
	inc	hl
	ret

; 0x0028`0x002f
; RST28
; LD (HL+),A
;
	org	$0028
	ld	(hl),a
	inc	hl
	ret

; 0x0030`0x0037
; RST30
; ėp
;
	org	$0030
	jp	CALL_SUB

; 0x0038`
; RST38ifobOpj
;
	org	$0038
	di
	halt

;
; RST30̃Wve[u
;
CALL_JPTBL:
	dw	LCDCNT		; 0x00
	dw	PALETCNT	; 0x01
	dw	SWAP_A		; 0x02

;
; SWAP A
;
SWAP_A:
	rlca
	rlca
	rlca
	rlca
	ret

;
; LCD
;
LCDCNT:
	push	af
	push	bc
	push	de
	push	hl

	ld	b,a
	ld	a,(OLD_LCDC)
	cp	b
	jr	z,.end
	ld	a,b

	ld	(GB_LCDC),a
	ld	(OLD_LCDC),a
	call	LCDCNT_SUB

.end:
	pop	hl
	pop	de
	pop	bc
	pop	af

	ret

;
; pbg
;
PALETCNT:
	push	af
	push	bc
	push	de
	push	hl

	ld	(GB_BGP),a
	ld	b,a
	ld	a,(OLD_BGP)
	cp	b
	ld	a,b
	ld	(OLD_BGP),a

	call	nz,CH_PALET

	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;
; 0x4000`0x7FFF̃oN؂ւ
;
SETBANK:
	push	af
	add	a,a		; x2
	add	a,a		; x4
	or	$20		; ORAM

	out	($62),a		; 0x4000-0x5fff̓ǂݏo
	out	($6a),a		; 0x4000-0x5fff̏
	add	a,2
	out	($63),a		; 0x6000-0x7fff̓ǂݏo
	out	($6b),a		; 0x6000-0x7fff̏

	pop	af
	ret

;
; ^C}bv`Ȃ
;

L_9818:
	push	hl
	ld	hl,$9818
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_981C:
	push	hl
	ld	hl,$981c
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_981D:
	push	hl
	ld	hl,$981d
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9848:
	push	hl
	ld	hl,$9848
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9867:
	push	hl
	ld	hl,$9867
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9868:
	push	hl
	ld	hl,$9868
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_986E:
	push	hl
	ld	hl,$986e
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_98EC:
	push	hl
	ld	hl,$98ec
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_992B:
	push	hl
	ld	hl,$992b
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_992C:
	push	hl
	ld	hl,$992c
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9989:
	push	hl
	ld	hl,$9989
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_99E1:
	push	hl
	ld	hl,$99e1
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_99E9:
	push	hl
	ld	hl,$99e9
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9C0B:
	push	hl
	ld	hl,$9c0b
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9C0D:
	push	hl
	ld	hl,$9c0d
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_9C0F:
	push	hl
	ld	hl,$9c0f
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_29C6:
	push	hl
	ld	hl,$9882
	rst	$10		; ld (hl),a
	ld	a,c
	ld	hl,$98a2
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_2A04:
	push	hl
	ld	hl,$9889
	rst	$10		; ld (hl),a
	pop	hl
	ld	a,(hl)
	push	hl
	ld	hl,$988a
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_2A21:
	push	hl
	ld	hl,$98a9
	rst	$10		; ld (hl),a
	pop	hl
	ld	a,(hl)
	push	hl
	ld	hl,$98aa
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_15CB:
	push	hl
	ld	h,b
	ld	l,c
	add	a,$71
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_15D1:
	push	hl
	ld	h,b
	ld	l,c
	ld	a,$71
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_15D5:
	push	hl
	ld	h,b
	ld	l,c
	ld	a,$70
	rst	$10		; ld (hl),a
	pop	hl
	ret

L_31CE:
	ld	d,a
.lp1:
	ld	a,d
	rst	$10		;ld (hl),a
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jp	nz,.lp1
	ret

L_3891:
	ld	a,(de)
	ld	(hl),a
	dec	hl
	inc	de
	ret

L_3AF3:
	ld	a,(hl)
	add	a,e
	ld	(hl),a
	dec	hl
	ld	a,(hl)
	adc	a,d
	ld	(hl),a
	dec	hl
	ret

L_22F4:
	add	hl,bc
	ld	a,(hl)
	dec	hl
	and	a
	ret

L_3B17:
	ld	a,(hl)
	sub	e
	ld	(hl),a
	dec	hl
	ret

L_3B22:
	sub	$18
	ld	(hl),a
	dec	hl
	ret

L_3B3C:
	ld	a,(hl)
	add	a,e
	ld	(hl),a
	dec	hl
	ret

L_3B4E:
	ld	(hl),a
	dec	hl
	ld	a,0
	ret

L_093D:
	ld	a,(hl)
	inc	hl
	ld	d,a
	ld	a,(hl)
	dec	hl
	ret


; 0x0182`
; ̂܂܎gp
;
	org	$0182
	db	$ff

; 0x0217`0x022e
; OAM]vO
;
	org	$0217
	ret

; 0x022f`
; ̂܂܎gp
;
	org	$022f
	db	$ff

; 0x08a6`0x08a8
; ^C}bv`
;
	org	$08a6
	call	L_9989

; 0x08a9`
; ̂܂܎gp
;
	org	$08a9
	db	$ff

; 0x08cc`0x08ce
; ^C}bv`
;
	org	$08cc
	call	L_98EC

; 0x08cf`
; ̂܂܎gp
;
	org	$08cf
	db	$ff

; 0x08f4`0x08f6
; ^C}bv`
;
	org	$08f4
	call	L_992B

; 0x08f7`
; ̂܂܎gp
;
	org	$08f7
	db	$ff

; 0x08f8`0x08fa
; ^C}bv`
;
	org	$08f8
	call	L_992C

; 0x08fb`
; ̂܂܎gp
;
	org	$08fb
	db	$ff

; 0x093d`0x093f
; LDH̏C
;
	org	$093d
	call	L_093D

; 0x0940`
; ̂܂܎gp
;
	org	$0940
	db	$ff

; 0x1346`0x1346
; ^C}bv`
;
	org	$1346
	rst	$18		;ld (de),a

; 0x1347`
; ̂܂܎gp
;
	org	$1347
	db	$ff

; 0x1552`0x1554
; ^C}bv`
;
	org	$1552
	call	L_986E

; 0x1555`
; ̂܂܎gp
;
	org	$1555
	db	$ff

; 0x1578`0x157a
; ^C}bv`
;
	org	$1578
	call	L_9848

; 0x157b`
; ̂܂܎gp
;
	org	$157b
	db	$ff

; 0x15cb`0x15cd
; ^C}bv`
;
	org	$15cb
	call	L_15CB

; 0x15ce`
; ̂܂܎gp
;
	org	$15ce
	db	$ff

; 0x15d1`0x15d3
; ^C}bv`
;
	org	$15d1
	call	L_15D1

; 0x15d4`
; ̂܂܎gp
;
	org	$15d4
	db	$ff

; 0x15d5`0x15d7
; ^C}bv`
;
	org	$15d5
	call	L_15D5

; 0x15d8`
; ̂܂܎gp
;
	org	$15d8
	db	$ff

; 0x16b5`0x16b7
; ^C}bv`
;
	org	$16b5
	call	L_9867

; 0x16b8`
; ̂܂܎gp
;
	org	$16b8
	db	$ff

; 0x16ba`0x16bc
; ^C}bv`
;
	org	$16ba
	call	L_9868

; 0x16bd`
; ̂܂܎gp
;
	org	$16bd
	db	$ff

; 0x16cb`0x16cd
; ^C}bv`
;
	org	$16cb
	call	L_9867

; 0x16ce`
; ̂܂܎gp
;
	org	$16ce
	db	$ff

; 0x16cf`0x16d1
; ^C}bv`
;
	org	$16cf
	call	L_9868

; 0x16d2`
; ̂܂܎gp
;
	org	$16d2
	db	$ff

; 0x18da`0x18dc
; ^C}bv`
;
	org	$18da
	call	L_9818

; 0x18dd`
; ̂܂܎gp
;
	org	$18dd
	db	$ff

; 0x18ea`0x18ec
; ^C}bv`
;
	org	$18ea
	call	L_981C

; 0x18ed`
; ̂܂܎gp
;
	org	$18ed
	db	$ff

; 0x18ee`0x18f0
; ^C}bv`
;
	org	$18ee
	call	L_981D

; 0x18f1`
; ̂܂܎gp
;
	org	$18f1
	db	$ff

; 0x1fb8`0x1fba
; ^C}bv`
;
	org	$1fb8
	call	L_9C0D

; 0x1fbb`
; ̂܂܎gp
;
	org	$1fbb
	db	$ff

; 0x1fc2`0x1fc4
; ^C}bv`
;
	org	$1fc2
	call	L_9C0F

; 0x1fc5`
; ̂܂܎gp
;
	org	$1fc5
	db	$ff

; 0x1ff0`0x1ff2
; ^C}bv`
;
	org	$1ff0
	call	L_9C0B

; 0x1ff3`
; ̂܂܎gp
;
	org	$1ff3
	db	$ff

; 0x22f4`0x22f6
; LDH̏C
;
	org	$22f4
	call	L_22F4

; 0x22f7`
; ̂܂܎gp
;
	org	$22f7
	db	$ff

; 0x230c`0x230c
; ^C}bv`
;
	org	$230c
	rst	$10		;ld (hl),a

; 0x230d`
; ̂܂܎gp
;
	org	$230d
	db	$ff

; 0x2450`0x2450
; ^C}bv`
;
	org	$2450
	rst	$10		;ld (hl),a

; 0x2451`
; ̂܂܎gp
;
	org	$2451
	db	$ff

; 0x2463`0x2463
; ^C}bv`
;
	org	$2463
	rst	$10		;ld (hl),a

; 0x2464`
; ̂܂܎gp
;
	org	$2464
	db	$ff

; 0x2474`0x2474
; ^C}bv`
;
	org	$2474
	rst	$10		;ld (hl),a

; 0x2475`
; ̂܂܎gp
;
	org	$2475
	db	$ff

; 0x29c6`0x29cd
; ^C}bv`
;
	org	$29c6
	jp	L_29C6

; 0x29ce`
; ̂܂܎gp
;
	org	$29ce
	db	$ff

; 0x2a04`0x2a0b
; ^C}bv`
;
	org	$2a04
	jp	L_2A04

; 0x2a0c`
; ̂܂܎gp
;
	org	$2a0c
	db	$ff

; 0x2a21`0x2a28
; ^C}bv`
;
	org	$2a21
	jp	L_2A21

; 0x2a29`
; ̂܂܎gp
;
	org	$2a29
	db	$ff

; 0x2ac0`0x2ac0
; yeXg[h̃L[͂̕ύX
;
	org	$2ac0
	db	$41

; 0x2ac1`
; ̂܂܎gp
;
	org	$2ac1
	db	$ff

; 0x2b7f`0x2b81
; ^C}bv`
;
	org	$2b7f
	call	L_99E1

; 0x2b82`
; ̂܂܎gp
;
	org	$2b82
	db	$ff

; 0x2b83`0x2b85
; ^C}bv`
;
	org	$2b83
	call	L_99E9

; 0x2b86`
; ̂܂܎gp
;
	org	$2b86
	db	$ff

; 0x3136`0x3136
; HALT̏C
;
	org	$3136
	nop

; 0x3137`
; ̂܂܎gp
;
	org	$3137
	db	$ff

; 0x314d`0x317d
; pbh
;
	org	$314d
	ld	a,(GAMEDATA)
	ld	b,a
	ld	a,($ff8b)
	xor	b
	and	b
	ld	($ff8c),a
	ld	a,b
	ld	($ff8b),a
	ret

; 0x317e`
; ̂܂܎gp
;
	org	$317e
	db	$ff

; 0x3195`0x3196
; LCD
;
	org	$3195
	nop
	nop

; 0x3197`
; ̂܂܎gp
;
	org	$3197
	db	$ff

; 0x31c6`0x31c6
; ^C}bv`
;
	org	$31c6
	rst	$18		;ld (de),a

; 0x31c7`
; ̂܂܎gp
;
	org	$31c7
	db	$ff

; 0x31ce`0x31d6
; ^C}bv`
;
	org	$31ce
	jp	L_31CE

; 0x31d7`
; ̂܂܎gp
;
	org	$31d7
	db	$ff

; 0x31db`0x31dd
; oN؊
;
	org	$31db
	nop
	nop
	nop

; 0x31de`
; ̂܂܎gp
;
	org	$31de
	db	$ff

; 0x31e9`0x31eb
; oN؊
;
	org	$31e9
	call	SETBANK

; 0x31ec`
; ̂܂܎gp
;
	org	$31ec
	db	$ff

; 0x31f1`0x31f3
; oN؊
;
	org	$31f1
	nop
	nop
	nop

; 0x31f4`
; ̂܂܎gp
;
	org	$31f4
	db	$ff

; 0x31fe`0x3200
; oN؊
;
	org	$31fe
	call	SETBANK

; 0x3201`
; ̂܂܎gp
;
	org	$3201
	db	$ff

; 0x3369`0x3376
; LDH̏C
;
	org	$3369
	jp	L_3369

; 0x3377`
; ̂܂܎gp
;
	org	$3377
	db	$ff

; 0x3891`0x3893
; LDH̏C
;
	org	$3891
	call	L_3891

; 0x3894`
; ̂܂܎gp
;
	org	$3894
	db	$ff

; 0x38f8`0x38ff
; SPޔ֘A
;
	org	$38f8
	di
	ld	($ffe8),sp
	nop
	nop
	nop

; 0x3900`
; ̂܂܎gp
;
	org	$3900
	db	$ff

; 0x394e`0x395b
; SPޔ֘A
;
	org	$394e
	ld	hl,$0000
	add	hl,sp
	ld	a,h
	ld	(de),a
	inc	de
	ld	a,l
	ld	(de),a
	ld	sp,($ffe8)
	ei

; 0x395c`
; ̂܂܎gp
;
	org	$395c
	db	$ff

; 0x3af3`0x3af9
; LDH̏C
;
	org	$3af3
	jp	L_3AF3

; 0x3afa`
; ̂܂܎gp
;
	org	$3afa
	db	$ff

; 0x3afe`0x3b04
; LDH̏C
;
	org	$3afe
	jp	L_3AF3

; 0x3b05`
; ̂܂܎gp
;
	org	$3b05
	db	$ff

; 0x3b17`0x3b19
; LDH̏C
;
	org	$3b17
	call	L_3B17

; 0x3b1a`
; ̂܂܎gp
;
	org	$3b1a
	db	$ff

; 0x3b22`0x3b24
; LDH̏C
;
	org	$3b22
	call	L_3B22

; 0x3b25`
; ̂܂܎gp
;
	org	$3b25
	db	$ff

; 0x3b3c`0x3b3e
; LDH̏C
;
	org	$3b3c
	call	L_3B3C

; 0x3b3f`
; ̂܂܎gp
;
	org	$3b3f
	db	$ff

; 0x3b4e`0x3b50
; LDH̏C
;
	org	$3b4e
	call	L_3B4E

; 0x3b51`
; ̂܂܎gp
;
	org	$3b51
	db	$ff

; 0x3f80`
; LDHCTu
;
	org	$3f80
	jp	L_B1_MPDE	; 0x3F80 + 0*3
	jp	L_3B17		; 0x3F80 + 1*3
	jp	L_B1_4DB7	; 0x3f80 + 2*3

L_B1_MPDE:
	ld	a,(hl)
	add	a,e
	ld	(hl),a
	dec	hl
	ret

L_B1_4DB7:
	ld	a,(hl)
	dec	hl
	add	a,$10
	ret

L_3369:
	ld	a,(hl)
	inc	hl
	push	hl
	ld	l,c
	ld	h,b
	call	WR_TILEMAP
	pop	hl
	inc	bc

	ld	a,(hl)
	inc	hl
	push	hl
	ld	l,c
	ld	h,b
	call	WR_TILEMAP
	pop	hl
	inc	bc

	ld	a,(hl)
	inc	hl
	ex	de,hl
	call	WR_TILEMAP
	ex	de,hl
	inc	de

	ld	a,(hl)
	ex	de,hl
	call	WR_TILEMAP
	ex	de,hl
	inc	de

	pop	hl
	ret



;
; vȌI
;
	org	$3fff
	db	$ff

;
; BIOSvOĂяo
;
	include "bios.asm"

